//+------------------------------------------------------------------+
//|                                                   GlassOanda.mq4 |
//|                                                          NIKKI21 |
//|                                                  nikki21@mail.ru |
//+------------------------------------------------------------------+
#property copyright "NIKKI21"
#property link      "nikki21@mail.ru"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
//---- input parameters
extern bool Show_Orders=true;
extern bool Show_Orders_Difference=true;
extern bool Show_Trades=false;
extern bool Show_Trades_Difference=false;
extern int TimeZone=2;
//---- buffers
double OpenPrice[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init(){
  SetIndexStyle(0,DRAW_ARROW);
  SetIndexBuffer(0,OpenPrice);
  SetIndexArrow(0,119);
  SetIndexEmptyValue(0,0);
  return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit(){
  ObjectsDeleteAll();
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){
  if (Period()>30) return(-1);
  int hBar;
  double OT_STEP;
  double TT_STEP;
  int TR_PREV;
  int BR_PREV;
  int TL_PREV;
  int BL_PREV;
  int i;
  int FO=FileOpen(Symbol()+".OANDA.ORDERS",FILE_CSV|FILE_READ,';');
  int FT=FileOpen(Symbol()+".OANDA.TRADES",FILE_CSV|FILE_READ,';');
  string OT_HASH="";
  string OT_TIME="";
  string OT_GRID="";
  string OT_LOAD="";
  string TT_HASH="";
  string TT_TIME="";
  string TT_GRID="";
  string TT_LOAD="";
  string TS;
  int OTR[4][179];
  int TTR[4][179];
  int pos=0;
  int shift=0;
  if ((FO>0)&&(FT>0)){ 
    ObjectsDeleteAll();
    while((!FileIsEnding(FO))&&(!FileIsEnding(FT))){
      OT_HASH=FileReadString(FO);
      OT_TIME=FileReadString(FO);
      OT_GRID=FileReadString(FO);
      OT_LOAD=FileReadString(FO);
      TT_HASH=FileReadString(FT);
      TT_TIME=FileReadString(FT);
      TT_GRID=FileReadString(FT);
      TT_LOAD=FileReadString(FT);
      if ((OT_TIME=="<TIME>")&&(TT_TIME=="<TIME>")){
        //     
        pos=0;
        shift=0;
        while(pos<4){
          TS=FileReadString(FO);
          OTR[pos][shift]=StrToDouble(TS);
          shift++;
          if (FileIsLineEnding(FO)){
            pos++;
            shift=0;
          }
        }
        pos=0;
        shift=0;
        while(pos<4){
          TTR[pos][shift]=StrToDouble(FileReadString(FT));
          shift++;
          if (FileIsLineEnding(FT)){
            pos++;
            shift=0;
          }
        }
        hBar=GetLastHalfHour(StrToTime(OT_LOAD)-TimeZone*60*60);
        OpenPrice[hBar]=Open[hBar];
        TS="OANDA_V_"+Time[hBar];
        ObjectCreate(TS,OBJ_VLINE,0,Time[hBar],0);
        ObjectSet(TS,OBJPROP_COLOR,Gray);
        OT_STEP=StrToDouble(OT_GRID)/179.0;
        TT_STEP=StrToDouble(TT_GRID)/179.0;
        TR_PREV=0;
        BR_PREV=0;
        TL_PREV=0;
        BL_PREV=0;
        for(i=0;i<170;i++){
          if ((OTR[2][i]-TL_PREV!=OTR[3][i]-BL_PREV)&&Show_Orders_Difference){
            TS="OANDA_B_O_"+Time[hBar]+"_"+(OpenPrice[hBar]-(i+1)*OT_STEP*Point);
            ObjectCreate(TS,OBJ_TREND,0,
                         Time[hBar],OpenPrice[hBar]-(i+1)*OT_STEP*Point,
                         Time[hBar-(OTR[2][i]-TL_PREV)+(OTR[3][i]-BL_PREV)],OpenPrice[hBar]-(i+1)*OT_STEP*Point);
            ObjectSet(TS,OBJPROP_RAY,false);
            ObjectSet(TS,OBJPROP_WIDTH,3);
            if ((OTR[2][i]-TL_PREV)>(OTR[3][i]-BL_PREV))
              ObjectSet(TS,OBJPROP_COLOR,Green);
            else
              ObjectSet(TS,OBJPROP_COLOR,Maroon);
          }
          if ((OTR[0][i]-TR_PREV!=OTR[1][i]-BR_PREV)&&Show_Orders_Difference){
            TS="OANDA_T_O_"+Time[hBar]+"_"+(OpenPrice[hBar]+(i+1)*OT_STEP*Point);
            ObjectCreate(TS,OBJ_TREND,0,
                         Time[hBar],OpenPrice[hBar]+(i+1)*OT_STEP*Point,
                         Time[hBar-(OTR[0][i]-TR_PREV)+(OTR[1][i]-BR_PREV)],OpenPrice[hBar]+(i+1)*OT_STEP*Point);
            ObjectSet(TS,OBJPROP_RAY,false);
            ObjectSet(TS,OBJPROP_WIDTH,3);
            if ((OTR[0][i]-TR_PREV)>(OTR[1][i]-BR_PREV))
              ObjectSet(TS,OBJPROP_COLOR,Green);
            else
              ObjectSet(TS,OBJPROP_COLOR,Maroon);
          }
          if ((OTR[0][i]-TR_PREV>0)&&Show_Orders){
            TS="OANDA_TR_O_"+Time[hBar]+"_"+(OpenPrice[hBar]+(i+1)*OT_STEP*Point);
            ObjectCreate(TS,OBJ_TREND,0,
                         Time[hBar],OpenPrice[hBar]+(i+1)*OT_STEP*Point,
                         Time[hBar-(OTR[0][i]-TR_PREV)],OpenPrice[hBar]+(i+1)*OT_STEP*Point);
            ObjectSet(TS,OBJPROP_RAY,false);
            if (Show_Orders_Difference)
              ObjectSet(TS,OBJPROP_WIDTH,1);
            else
              ObjectSet(TS,OBJPROP_WIDTH,3);
            ObjectSet(TS,OBJPROP_COLOR,LimeGreen);
          }
          if ((OTR[1][i]-BR_PREV>0)&&Show_Orders){
            TS="OANDA_BR_O_"+Time[hBar]+"_"+(OpenPrice[hBar]+(i+1)*OT_STEP*Point);
            ObjectCreate(TS,OBJ_TREND,0,
                         Time[hBar],OpenPrice[hBar]+(i+1)*OT_STEP*Point,
                         Time[hBar+(OTR[1][i]-BR_PREV)],OpenPrice[hBar]+(i+1)*OT_STEP*Point);
            ObjectSet(TS,OBJPROP_RAY,false);
            if (Show_Orders_Difference)
              ObjectSet(TS,OBJPROP_WIDTH,1);
            else
              ObjectSet(TS,OBJPROP_WIDTH,3);
            ObjectSet(TS,OBJPROP_COLOR,Red);
          }
          TR_PREV=OTR[0][i];
          BR_PREV=OTR[1][i];
          if ((OTR[2][i]-TL_PREV>0)&&Show_Orders){
            TS="OANDA_TL_O_"+i+Time[hBar]+"_"+(OpenPrice[hBar]-(i+1)*OT_STEP*Point);
            ObjectCreate(TS,OBJ_TREND,0,
                         Time[hBar],OpenPrice[hBar]-(i+1)*OT_STEP*Point,
                         Time[hBar-(OTR[2][i]-TL_PREV)],OpenPrice[hBar]-(i+1)*OT_STEP*Point);
            ObjectSet(TS,OBJPROP_RAY,false);
            if (Show_Orders_Difference)
              ObjectSet(TS,OBJPROP_WIDTH,1);
            else
              ObjectSet(TS,OBJPROP_WIDTH,3);
            ObjectSet(TS,OBJPROP_COLOR,LimeGreen);
          }
          if ((OTR[3][i]-BL_PREV>0)&&Show_Orders){
            TS="OANDA_BL_O_"+Time[hBar]+"_"+(OpenPrice[hBar]-(i+1)*OT_STEP*Point);
            ObjectCreate(TS,OBJ_TREND,0,
                         Time[hBar],OpenPrice[hBar]-(i+1)*OT_STEP*Point,
                         Time[hBar+(OTR[3][i]-BL_PREV)],OpenPrice[hBar]-(i+1)*OT_STEP*Point);
            ObjectSet(TS,OBJPROP_RAY,false);
            if (Show_Orders_Difference)
              ObjectSet(TS,OBJPROP_WIDTH,1);
            else
              ObjectSet(TS,OBJPROP_WIDTH,3);
            ObjectSet(TS,OBJPROP_COLOR,Red);
          }
          TL_PREV=OTR[2][i];
          BL_PREV=OTR[3][i];
        }
      }
    }
  }
  if (FO>0) FileClose(FO);
  if (FT>0) FileClose(FT);
  return(0);
}
//+------------------------------------------------------------------+
int GetLastHalfHour(datetime T){
  bool exact;
  int result=iBarShift(NULL,0,MathFloor(1.0*(T-30*60)/(60*60))*60*60+60*30,exact);
  return(result);
}
//+------------------------------------------------------------------+